$(document).ready(function() {
	var lastDegree=0 //degree when mousedown ended
	var currentDegree=0  //current degree as mouse moves
	var aElem=$(".aims_tech")[0]; //element
	var bElem=$(".aims_tech");
	var startDragDegree; //degree when mousedown started
	
	function findCenter(elem){//find center of element
		var topPos = elem.getBoundingClientRect().top + window.scrollY+40;
		var leftPos = elem.getBoundingClientRect().left + window.scrollX;
	  var x = (leftPos) + (elem.offsetWidth / 2);
	  var y = (topPos) + (elem.offsetHeight / 2);
	   console.log(elem.offsetTop);
	   console.log(topPos);	 
	  return {x,y}	
	}
	
	
	// touch operation start
	function rotateOntouch(e, pw) {
	  //var center = findCenter(aElem)
	  const touch = e.changedTouches[ 0 ];
	  var mouse = {x: touch.pageX, y:touch.pageY};
	  var radians = Math.atan2(mouse.x - center.x, mouse.y - center.y);
	  var currentMouseDegree = (radians * (180 / Math.PI) * -1);
	  currentDegree = (currentMouseDegree-startDragDegree)+lastDegree;
	  let currentDegree2=(currentDegree*(-1));
	  console.log("rep-"+startDragDegree)
	  $(bElem).css({
		'-moz-transform': 'rotate(' + currentDegree + 'deg)',
		'-webkit-transform': 'rotate(' + currentDegree + 'deg)',
		'-o-transform': 'rotate(' + currentDegree + 'deg)',
		'-ms-transform': 'rotate(' + currentDegree + 'deg)'
	  });
	  bElem.find('div').each(function(){
		$(this).css({
			'-moz-transform': 'rotate(' + currentDegree2 + 'deg)',
			'-webkit-transform': 'rotate(' + currentDegree2 + 'deg)',
			'-o-transform': 'rotate(' + currentDegree2 + 'deg)',
			'-ms-transform': 'rotate(' + currentDegree2 + 'deg)'
		  });
		});

	}
	if( document.ontouchmove === undefined ) {
		console.log( "please enable your dev-tools's Responsive mode" );
	  }

	  document.querySelectorAll( '.aims_tech' ).forEach( (elem) => {
		// elem.addEventListener( 'touchstart', prevent );
		elem.addEventListener( 'touchmove', rotateOntouch );
		elem.addEventListener( 'touchstart', handleTouchStart );
	  } );
	
	  function handleTouchStart(e){
		e.preventDefault();
		const touch = e.touches[ 0 ];
		var mouseInitial = {x: touch.pageX, y:touch.pageY};    
		var center = findCenter(aElem)
		var radians = Math.atan2(mouseInitial.x - center.x, mouseInitial.y - center.y);
		startDragDegree = (radians * (180 / Math.PI) * -1);
		console.log('test'+startDragDegree);
		touchcloseDragElement();
	  }

	  function touchcloseDragElement() {
		lastDegree = currentDegree;
		document.onmouseup = null;
		document.onmousemove = null;
	  }
	  
	  

	  //touch opertations ends


	  function rotateOnMouse(e, pw) {
		var center = findCenter(pw[0])
		//var center2= getBoundingBox(pw[0])
		
		 console.log(center);
		//var center = {x: 400, y: 1352};
		
		var mouse = {x: e.pageX, y:e.pageY};
		 //console.log(center);
		//console.log(center2);
		// console.log(mouse);
		var radians = Math.atan2(mouse.x - center.x, mouse.y - center.y);
		var currentMouseDegree = (radians * (180 / Math.PI) * -1);
		currentDegree = (currentMouseDegree-startDragDegree)+lastDegree;
		let currentDegree2 = (currentDegree)*-1;
		$(pw).css({
		  '-moz-transform': 'rotate(' + currentDegree + 'deg)',
		  '-webkit-transform': 'rotate(' + currentDegree + 'deg)',
		  '-o-transform': 'rotate(' + currentDegree + 'deg)',
		  '-ms-transform': 'rotate(' + currentDegree + 'deg)'
		});
		$(pw).find('div').each(function(){
			$(this).css({
				'-moz-transform': 'rotate(' + currentDegree2 + 'deg)',
				'-webkit-transform': 'rotate(' + currentDegree2 + 'deg)',
				'-o-transform': 'rotate(' + currentDegree2 + 'deg)',
				'-ms-transform': 'rotate(' + currentDegree2 + 'deg)'
			  });
		});
	  }
	  
	
	$('.aims_tech').on('mousedown',function(e) {
		// $(this).closest('#rotative-container').attr('style', 'position: static !important');
	  e.preventDefault();
	  var mouseInitial = {x: e.pageX, y:e.pageY};    
	  var center = findCenter($(".aims_tech")[0])
	  var radians = Math.atan2(mouseInitial.x - center.x, mouseInitial.y - center.y);
	  startDragDegree = (radians * (180 / Math.PI) * -1);
	  
	  document.onmouseup = closeDragElement;
	  document.onmousemove = function(e2) {
		rotateOnMouse(e2, $('.aims_tech'));
	  };
	 
	});
  
	function closeDragElement() {
	  lastDegree = currentDegree;
	  document.onmouseup = null;
	  document.onmousemove = null;
	}

	var controller = new ScrollMagic.Controller();

	var scene = new ScrollMagic.Scene({
			triggerElement: '#rotative-container',			
			triggerHook: 0,
			duration: 1000,		
			reverse: true
		})
		.setPin('#rotative-container')
		 .offset(-20)
		.addIndicators()
		.addTo(controller);

	scene.on("progress", function (event) {
		var theta = $(window).scrollTop() / 100 % Math.PI;
		var currentDegree2 = theta*(-1);
		$('.aims_tech').css({
			'-moz-transform': 'rotate(' + theta + 'rad)',
			'-webkit-transform': 'rotate(' + theta + 'rad)',
			'-o-transform': 'rotate(' + theta + 'rad)',
			'-ms-transform': 'rotate(' + theta + 'rad)'
		  });
		  $('.aims_tech').find('div').each(function(){
			$(this).css({
				'-moz-transform': 'rotate(' + currentDegree2 + 'rad)',
				'-webkit-transform': 'rotate(' + currentDegree2 + 'rad)',
				'-o-transform': 'rotate(' + currentDegree2 + 'rad)',
				'-ms-transform': 'rotate(' + currentDegree2 + 'rad)'
			  });
		});
		  
	});																							
  });
  